class Tile extends BaseEntity
  constructor: (options) ->
    super options

    resTypes = (k for own k of app.game.resources)
    
    @layers = []
    for restype, i in resTypes
      @layers.push new Tilelayer(
        type: restype,
        depth: i,
        amount: Math.random(5)+10
      )
    
    @currentLayer = 0
    @isActive = false

  click: (button)->
	@isSelected = true
    if button == "left" and @layers[@currentLayer].collect()
      name = app.layerIndexToName(@currentLayer)
      console.log(name)
      app.game.resources[name] += 1

  moveIn: ->
    @isActive = true

  moveOut: ->
    @isActive = false
    
  tick: (delta) ->
    # TODO: digging deeper?

  render: (x, y)->
    tileLayer = @layers[@currentLayer]
    app.layer.drawRegion app.images.layers, tileLayer.sprite, x*8, y*8

    if @isSelected    
      app.layer.drawImage app.images.selected, x*8, y*8
    else if @isActive
      app.layer.drawImage app.images.active, x*8, y*8
